; Define name of registers
.alias flag 2
.alias flag2 3
.include "HDL50001_pcf.inc"

.text

start:
	jmp systimer
complete

;;;;; Processing systimer ;;;;;
systimer:
	jmp initSysTimer
	setl #flag, 0
	setl #flag2, 240 ;value for manage time interval (120 - 10Hz)
complete
;; Set counter period
initSysTimer:
	jmp StartSysTimer
	getl 0x0000FFFF
	setl #STVALR, @1 
complete
;;Start counter, use periodic mode
StartSysTimer:
	jmp SysTimerFinish
	getl 0x00000003
	setl #STCR, @1
complete
;;Wait for SysTimer finish
SysTimerFinish:
	getl #INTR
	getl 0x00000020
	and @2,@1
	je @1, SysTimerFinish
	jne @2, PortOut
complete
;;Choose (on or off) led on GPIOA
PortOut:
	getl #INTR
	getl 0x00000020
	not @1
	and @3,@1
	setl #INTR, @1
	getl #flag
	je @1, Ledoff
	jne @2, Ledon
complete
;;Led off
Ledoff:
	getl #flag2
	subl @1, 1
	je @2, disable
	jne @3, SysTimerFinish
	setl #flag2, @3
	getl #STCR
	and @1, 0xFFFFFFFB
	setl #STCR, @1
complete

; enable led 2,3
enable:
	jmp SysTimerFinish
	getl 0x60000000
	wrl @1, GPIOB_DIR
	getl 0x00000000
	wrl @1, GPIOB_OUT
	setl #flag2, 240
	setl #flag, 0	
complete
;;Led on
Ledon:
	getl #flag2
	subl @1, 1
	je @2, enable
	jne @3, SysTimerFinish
	setl #flag2, @3
	getl #STCR
	and @1, 0xFFFFFFFB
	setl #STCR, @1
complete

; disable led 2,3
disable:
	jmp SysTimerFinish
	getl 0x60000000
	wrsl @1, GPIOB_DIR
	getl 0x60000000
	wrl @1, GPIOB_OUT ;set PortB 29,30 pin
	setl #flag2, 240
	setl #flag, 1
complete








