; Define name of registers
.alias flag 2
.alias flag2 3
.include "HDL50001_pcf.inc"

.text

start:
	jmp systimer
complete

;;;;; Processing systimer ;;;;;
systimer:
	jmp initSysTimer
	setl #IHOOKADDR,P1
	setl #flag, 0
	setl #flag2, 120 ;value for time interval
complete
;Interrupt handler
P1:
	getl #flag2
	subl @1, 1
	setl #flag2, @1
	getl #STCR
	and @1, 0xFFFFFFFB
	setl #STCR, @1
	getl #flag
	je @1, Ledoff
	jne @2, Ledon
complete
;; Set counter period and allow interrupt from systimer
initSysTimer:
	jmp MainLoop
	setl #PSW, 1
	getl 0x0000FFFF
	setl #STVALR, @1 
	getl 0x00000002
	setl #MSKR, @1
	getl 0x00000003
	setl #STCR, @1
complete
;;Start counter, use periodic mode
MainLoop:
	jmp MainLoop
complete
;;Led off
Ledoff:
	getl #flag2
	je @1, disable
	jne @2, #IRETADDR
	setl #PSW, 1
complete

; disable led 2,3
disable:
	jmp #IRETADDR
	getl 0x60000000
	wrl @1, GPIOB_DIR
	getl 0x00000000
	wrl @1, GPIOB_OUT
	setl #flag2, 120
	setl #flag, 1
complete

;;Led on
Ledon:
	getl #flag2
	je @1, enable
	jne @2, #IRETADDR
	setl #PSW, 1
complete

; enable led 2,3
enable:
	jmp #IRETADDR
	getl 0x60000000
	wrl @1, GPIOB_DIR
	getl 0x60000000
	wrl @1, GPIOB_OUT ;set PortB 29,30 pin
	setl #flag2, 120
	setl #flag, 0
complete









