//Uart test
#include <HDL51001_ccf.h>
#include <wdt.h>


#define S1(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 20)) : (GPIOB->OUT & (~(1 << 20))) )
#define S2(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 21)) : (GPIOB->OUT & (~(1 << 21))) )
#define S3(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 23)) : (GPIOB->OUT & (~(1 << 23))) )
#define S4(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 24)) : (GPIOB->OUT & (~(1 << 24))) )
#define DA(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 25)) : (GPIOB->OUT & (~(1 << 25))) )
#define DB(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 26)) : (GPIOB->OUT & (~(1 << 26))) )
#define DC(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 27)) : (GPIOB->OUT & (~(1 << 27))) )
#define DD(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 28)) : (GPIOB->OUT & (~(1 << 28))) )
#define DE(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 29)) : (GPIOB->OUT & (~(1 << 29))) )
#define DF(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 30)) : (GPIOB->OUT & (~(1 << 30))) )
#define DG(V) GPIOB->OUT = (((V & 0x01) == 1) ? (GPIOB->OUT | ((V & 0x01) << 31)) : (GPIOB->OUT & (~(1 << 31))) )

#define led7_pause 5000

void led7_zero()
{
	DA(0);
	DB(0);
	DC(0);
	DD(0);
	DE(0);
	DF(0);
	DG(1);
}

void led7_one()
{
	DA(1);
	DB(0);
	DC(0);
	DD(1);
	DE(1);
	DF(1);
	DG(1);
}

void led7_two()
{
	DA(0);
	DB(0);
	DC(1);
	DD(0);
	DE(0);
	DF(1);
	DG(0);
}

void led7_three()
{
	DA(0);
	DB(0);
	DC(0);
	DD(0);
	DE(1);
	DF(1);
	DG(0);
}

void led7_four()
{
	DA(1);
	DB(0);
	DC(0);
	DD(1);
	DE(1);
	DF(0);
	DG(0);
}

void led7_five()
{
	DA(0);
	DB(1);
	DC(0);
	DD(0);
	DE(1);
	DF(0);
	DG(0);
}

void led7_six()
{
	DA(0);
	DB(1);
	DC(0);
	DD(0);
	DE(0);
	DF(0);
	DG(0);
}

void led7_seven()
{
	DA(0);
	DB(0);
	DC(0);
	DD(1);
	DE(1);
	DF(1);
	DG(1);
}

void led7_eight()
{
	DA(0);
	DB(0);
	DC(0);
	DD(0);
	DE(0);
	DF(0);
	DG(0);
}

void led7_nine()
{
	DA(0);
	DB(0);
	DC(0);
	DD(1);
	DE(1);
	DF(0);
	DG(0);
}




void led7_out(unsigned int number)
{
	unsigned int a[4] = {0,0,0,0};
	int j;
	int k;
	j = 0;
	
	if(number > 9999)
	{
		DA(1);
		DB(1);
		DC(1);
		DD(1);
		DE(1);
		DF(1);
		DG(0);	//set tire
		return;
	}
	
	while(number)
	{
		a[j] = number % 10;
		number = number / 10;
		j++;
	}
	
	while(1)
	{
		S1(1);
		S2(1);
		S3(0);
		S4(1);
		switch(a[1])
		{
			case 0: led7_zero();break;
			case 1: led7_one();break;
			case 2: led7_two();break;
			case 3: led7_three();break;
			case 4: led7_four();break;
			case 5: led7_five();break;
			case 6: led7_six();break;
			case 7: led7_seven();break;
			case 8: led7_eight();break;
			case 9: led7_nine();break;
		}
		for(k=0;k<led7_pause;k++);
		S1(1);
		S2(0);
		S3(1);
		S4(1);
		switch(a[2])
		{
			case 0: led7_zero();break;
			case 1: led7_one();break;
			case 2: led7_two();break;
			case 3: led7_three();break;
			case 4: led7_four();break;
			case 5: led7_five();break;
			case 6: led7_six();break;
			case 7: led7_seven();break;
			case 8: led7_eight();break;
			case 9: led7_nine();break;
		}
		for(k=0;k<led7_pause;k++);
		S1(1);
		S2(1);
		S3(1);
		S4(0);
		switch(a[0])
		{
			case 0: led7_zero();break;
			case 1: led7_one();break;
			case 2: led7_two();break;
			case 3: led7_three();break;
			case 4: led7_four();break;
			case 5: led7_five();break;
			case 6: led7_six();break;
			case 7: led7_seven();break;
			case 8: led7_eight();break;
			case 9: led7_nine();break;
		}
		for(k=0;k<led7_pause;k++);
		S1(0);
		S2(1);
		S3(1);
		S4(1);
		switch(a[3])
		{
			case 0: led7_zero();break;
			case 1: led7_one();break;
			case 2: led7_two();break;
			case 3: led7_three();break;
			case 4: led7_four();break;
			case 5: led7_five();break;
			case 6: led7_six();break;
			case 7: led7_seven();break;
			case 8: led7_eight();break;
			case 9: led7_nine();break;
		}
		for(k=0;k<led7_pause;k++);
	}
	
	
	
}


void main() 
{
	int i;
	WDT_OFF;
	
	GPIOB->DIR = ((uint32_t)0xFFB00000);
	
    led7_out(705);
	
}













